﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.EJ2.Base;
using System.Collections;
using System.Data;

namespace filter_core.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public IActionResult Index()
        {
            ViewBag.dataSource = Orders.getAllRecords().ToList();
            return View();
        }

        public bool validateID([FromBody] int id)
        {
            return id % 2 == 0; 
        }

        public IActionResult UrlDatasource([FromBody] DataManagerRequest dm)
        {
            IEnumerable DataSource = Orders.getAllRecords();
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Orders>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, bool Verified, double Freight, DateTime OrderDate, string ShipCity, string ShipCountry)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.Verified = Verified;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
                this.ShipCountry = ShipCountry;
                
            }

            public static List<Orders> getAllRecords()
            {
                if (order.Count == 0)
                {
                    int code = 10000;
                    for (int i = 1; i < 400; i++)
                    {
                        order.Add(new Orders(code + 1, "ALFKI", i + 0, true, 2.3 * i, new DateTime(2020, 05, 08), "Paid", "Denmark"));
                        order.Add(new Orders(code + 2, "ALFKI", i + 2, false, 3.3 * i, new DateTime(2019, 10, 06), "Delivered", "Brazil"));
                        order.Add(new Orders(code + 3, "ALFKI", i + 2, false, 3.3 * i, new DateTime(2019, 10, 06), "Delivered", "Brazil"));
                        order.Add(new Orders(code + 4, "ALFKI", i + 2, false, 3.3 * i, new DateTime(2019, 10, 06), "Not-Paid", "Brazil"));
                        order.Add(new Orders(code + 5, "ANTON", i + 1, true, 4.3 * i, new DateTime(2020, 05, 07), "Not-Paid", "Germany"));
                        code += 5;
                    }
                }
                return order;
            }

            public long OrderID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }

            public bool Verified { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
            public string ShipCountry { get; set; }
        }
    }

}
